Search.setIndex({"docnames": ["algorithm", "core", "disk-format", "events", "index", "messages", "quick-start", "types", "updates"], "filenames": ["algorithm.rst", "core.rst", "disk-format.rst", "events.rst", "index.rst", "messages.rst", "quick-start.rst", "types.rst", "updates.rst"], "titles": ["<code class=\"xref c c-struct docutils literal notranslate\"><span class=\"pre\">raft</span></code> \u2014 Algorithm state", "Core API", "Disk format", "<code class=\"xref c c-struct docutils literal notranslate\"><span class=\"pre\">raft_event</span></code> \u2014 External events", "C-Raft", "<code class=\"xref c c-struct docutils literal notranslate\"><span class=\"pre\">raft_message</span></code> \u2014 RPC messages", "Quick start", "Basic types", "<code class=\"xref c c-struct docutils literal notranslate\"><span class=\"pre\">raft_update</span></code> \u2014 State updates"], "terms": {"The": [0, 2, 3, 4, 5, 8], "struct": [0, 3, 5, 6, 7, 8], "central": 0, "part": [0, 2, 4], "c": [0, 6], "It": [0, 3, 4], "holds": [0, 3, 5, 8], "drive": 0, "single": [0, 5, 6, 7], "server": [0, 1, 2, 5, 6, 7, 8], "cluster": 0, "purely": 0, "finite": 0, "machine": [0, 6], "doesn": 0, "t": [0, 2], "perform": 0, "any": [0, 2, 3, 7, 8], "i": [0, 3, 4, 6, 8], "o": [0, 3, 4, 6, 8], "system": [0, 4, 6], "calls": [0, 4], "raft_step": [0, 3, 8], "function": [0, 3], "used": [0, 2, 4], "advance": 0, "designed": [0, 4], "integrated": 0, "some": [0, 3], "external": [0, 1], "event": [0, 3, 8], "loop": [0, 6], "layer": [0, 3], "charge": 0, "receiving": 0, "users": [0, 3, 4, 8], "requests": 0, "implementing": [0, 3, 8], "network": [0, 4, 5], "communication": [0, 4], "other": [0, 2, 8], "servers": [0, 4, 8], "persisting": [0, 3], "disk": [0, 3, 4, 5, 8], "For": [0, 2], "example": [0, 2], "A": [0, 3, 7], "requestvote": [0, 1], "rpc": [0, 1], "message": [0, 3, 5], "has": [0, 2, 3, 4, 8], "been": [0, 2, 3, 8], "received": [0, 3, 5], "from": [0, 3], "we": [0, 2], "inform": 0, "about": [0, 2, 3, 5, 8], "passing": [0, 3], "raft_event": [0, 1], "raft_update": [0, 1], "update": 0, "type": [0, 3, 5, 6, 7], "raft_receive": [0, 3], "receive": [0, 1], "fill": 0, "content": 0, "object": 0, "contains": [0, 2, 3], "information": [0, 3, 5, 8], "next": [0, 8], "actions": [0, 8], "should": [0, 2, 3, 5, 8], "might": 0, "contain": [0, 2], "new": [0, 2, 3, 5, 8], "messages": [0, 1], "sent": [0, 5, 8], "flags": [0, 5, 8], "raft_update_messages": [0, 8], "unsigned": [0, 3, 5, 6, 7, 8], "0": [0, 6, 8], "n": [0, 3, 6, 8], "send": [0, 8], "contained": 0, "batch": [0, 2, 7, 8], "basically": 0, "whenever": 0, "an": [0, 2, 3, 5], "occurs": [0, 2], "must": [0, 3, 8], "called": 0, "resulting": 0, "updates": [0, 1], "performed": 0, "see": [0, 4], "events": [0, 1], "section": 0, "details": [0, 8], "what": 0, "pass": 0, "step": 0, "order": 0, "forward": 0, "how": 0, "processed": [0, 3, 8], "after": [0, 2, 8], "calling": [0, 8], "enum": [0, 3, 5, 7], "raft_state": [0, 8], "code": [0, 2, 3, 4, 5, 8], "possible": 0, "states": 0, "can": [0, 2, 4, 6, 8], "raft_follower": 0, "1": [0, 2, 3, 5, 6, 7, 8], "raft_candidate": 0, "raft_leader": 0, "raft_id": [0, 3, 5, 6, 7], "id": [0, 2, 3, 5, 6, 7, 8], "readonly": 0, "int": [0, 6], "raft_init": 0, "r": 0, "const": [0, 5, 6], "char": [0, 3, 5, 6], "address": [0, 5, 6], "initialize": 0, "raft_close": 0, "close": 0, "releasing": 0, "all": [0, 2, 3, 4, 5, 7], "memory": [0, 7], "uses": 0, "given": [0, 2], "raft_term": [0, 3, 5, 7], "raft_current_term": [0, 8], "return": [0, 6], "current": [0, 1, 2, 3, 5], "term": [0, 1, 2, 3, 5, 7], "raft_voted_for": [0, 8], "voted": [0, 1, 2], "expr": 0, "did": 0, "vote": [0, 2, 3, 5, 8], "follower": 0, "candidate": [0, 5], "leader": [0, 3, 4, 5], "raft_index": [0, 3, 5, 7, 8], "raft_commit_index": [0, 8], "commit": [0, 1, 5], "index": [0, 1, 2, 3, 5, 7], "raft_time": [0, 3, 7], "raft_timeout": [0, 3, 8], "time": [0, 2, 3, 7, 8], "which": [0, 2, 7, 8], "fired": [0, 8], "raft": [1, 2, 3, 6, 7, 8], "algorithm": [1, 4], "state": [1, 3, 6], "data": [1, 2, 4], "types": 1, "public": 1, "members": 1, "common": 1, "fields": 1, "start": [1, 2], "persisted": [1, 8], "entries": [1, 2, 5], "snapshot": [1, 5], "configuration": [1, 7], "taken": 1, "submit": 1, "catch": 1, "up": 1, "transfer": [1, 4], "leadership": [1, 4], "timeout": [1, 3], "raft_message": [1, 3, 8], "result": 1, "appendentries": 1, "installsnapshot": 1, "timeoutnow": 1, "basic": [1, 4, 6], "implementation": [2, 4], "metadata": [2, 3, 8], "log": [2, 3, 4, 5, 7, 8], "persistency": 2, "virtually": 2, "same": 2, "one": 2, "found": 2, "logcabin": 2, "files": 2, "consist": 2, "closed": 2, "segments": 2, "open": 2, "track": 2, "s": [2, 4, 5, 7], "contiguous": 2, "never": 2, "written": 2, "again": 2, "may": 2, "renamed": 2, "truncated": 2, "suffix": 2, "where": 2, "newly": 2, "appended": 2, "go": 2, "once": 2, "segment": 2, "reaches": 2, "maximum": 2, "allowed": 2, "size": [2, 5], "There": 2, "usually": 2, "3": [2, 8], "lower": 2, "actively": 2, "being": [2, 3, 5], "ones": [2, 5], "have": [2, 3], "fallocate": 2, "d": 2, "ready": 2, "soon": 2, "active": 2, "gets": 2, "named": 2, "metadata1": 2, "metadata2": 2, "alternates": 2, "between": 2, "so": 2, "always": [2, 3], "least": [2, 7], "readable": 2, "file": [2, 6], "On": [2, 4, 6], "startup": 2, "higher": 2, "version": [2, 4, 5], "number": [2, 8], "8": 2, "bytes": 2, "currently": 2, "incremental": 2, "values": 2, "little": 2, "endian": 2, "encoding": 2, "string": 2, "lu": 2, "end": 2, "indexes": 2, "both": 2, "inclusive": 2, "entry": [2, 3, 5, 7, 8], "large": 2, "occasionally": 2, "include": [2, 6], "past": 2, "filename": 2, "ignored": 2, "warning": 2, "logged": 2, "This": [2, 4, 8], "happen": 2, "crash": 2, "inopportune": 2, "first": [2, 3, 8], "unique": 2, "These": 2, "exist": 2, "when": [2, 3, 4], "shuts": 2, "down": [2, 4], "cleanly": 2, "while": 2, "running": 2, "left": 2, "around": 2, "during": 2, "either": 2, "come": 2, "last": [2, 3, 5, 8], "full": [2, 4], "zeros": 2, "crashes": 2, "appending": 2, "corrupt": 2, "distinguish": 2, "partially": 2, "assumes": 2, "logs": 2, "ignores": 2, "truncating": 2, "remove": 2, "longer": 2, "prefix": 2, "only": [2, 4], "complete": 2, "before": [2, 8], "10": [2, 6], "through": 2, "20": 2, "15": 2, "entire": 2, "retained": 2, "each": [2, 3], "starts": 2, "header": 2, "just": [2, 6], "byte": 2, "concatenation": 2, "serialized": 2, "batches": 2, "following": 2, "4": [2, 3, 8], "crc32": 2, "checksum": 2, "more": 2, "passed": 3, "raft_event_type": [3, 5], "codes": [3, 5, 7], "raft_start": 3, "initial": 3, "starting": 3, "loading": 3, "another": 3, "raft_persisted_entries": 3, "raft_persisted_snapshot": 3, "raft_configuration": [3, 5, 6], "committed": 3, "applied": [3, 7], "raft_snapshot": 3, "expired": 3, "raft_submit": 3, "submitted": 3, "raft_catch_up": 3, "catching": 3, "raft_transfer": 3, "transferring": 3, "completed": 3, "replication": [3, 4], "core": [3, 4, 8], "responsible": [3, 8], "watches": 3, "above": [3, 8], "filling": 3, "objects": 3, "appropriate": 3, "them": 3, "associated": 3, "sub": 3, "whose": 3, "described": [3, 4, 8], "separately": 3, "sections": 3, "below": 3, "filled": 3, "unused": 3, "short": [3, 5, 7], "capacity": [3, 5], "reserved": [3, 5], "union": [3, 5], "additional": 3, "specific": [3, 5], "persisted_entries": 3, "persisted_snapshot": 3, "catch_up": 3, "timestamp": 3, "guaranteed": [3, 7], "available": [3, 4], "anonymous": [3, 8], "To": 3, "voted_for": 3, "raft_snapshot_metadata": [3, 8], "start_index": 3, "raft_entry": [3, 5, 7, 8], "array": [3, 5, 8], "n_entries": [3, 5], "length": [3, 7], "latest": 3, "successfully": 3, "highest": 3, "size_t": [3, 7, 8], "offset": [3, 8], "bool": [3, 5, 8], "conf": [3, 5, 6], "trailing": 3, "kept": 3, "caught": 3, "server_id": [3, 5], "transfered": 3, "production": 4, "grade": 4, "asynchronous": 4, "consensus": 4, "protocol": 4, "library": 4, "modular": 4, "its": 4, "implements": [4, 6], "logic": 4, "top": 4, "various": 4, "drivers": 4, "provided": 4, "implement": 4, "actual": 4, "persistent": 4, "storage": 4, "work": 4, "well": 4, "non": [4, 5], "blocking": 4, "engines": 4, "libuv": [4, 6], "io_uring": 4, "although": 4, "threaded": 4, "contexts": 4, "dissertation": 4, "election": 4, "compaction": 4, "membership": 4, "changes": [4, 8], "also": 4, "includes": 4, "few": 4, "optional": 4, "enhancements": 4, "optimistic": 4, "pipelining": 4, "reduce": 4, "latency": 4, "writing": 4, "parallel": 4, "automatic": 4, "stepping": 4, "loses": 4, "quorum": 4, "extension": 4, "voting": 4, "tree": 4, "github": 4, "released": 4, "under": 4, "slightly": 4, "modified": 4, "lgplv3": 4, "copyright": 4, "exception": 4, "letting": 4, "statically": 4, "link": 4, "project": 4, "release": 4, "final": 4, "own": 4, "terms": 4, "license": 4, "text": 4, "over": 5, "raft_message_type": 5, "raft_append_entries": 5, "raft_append_entries_result": 5, "raft_request_vote": 5, "raft_request_vote_result": 5, "raft_install_snapshot": 5, "raft_timeout_now": 5, "structs": 5, "plus": 5, "sender": 5, "receiver": 5, "depending": 5, "whether": 5, "sending": 5, "destination": 5, "server_address": 5, "request_vote": 5, "request_vote_result": 5, "append_entries": 5, "append_entries_result": 5, "install_snapshot": 5, "timeout_now": 5, "parameters": 5, "format": 5, "candidate_id": 5, "requesting": 5, "last_log_index": 5, "last_log_term": 5, "disrupt_leader": 5, "true": [5, 8], "discarded": 5, "pre_vote": 5, "pre": 5, "request": 5, "current_term": 5, "rejected": 5, "If": [5, 8], "zero": 5, "hint": 5, "features": 5, "feature": 5, "since": [5, 7], "prev_log_index": 5, "preceeding": 5, "prev_log_term": 5, "leader_commit": 5, "append": 5, "last_index": 5, "last_term": 5, "config": [5, 6, 7], "conf_index": 5, "raft_buffer": [5, 6, 7, 8], "raw": 5, "make": 6, "sure": 6, "autotools": 6, "libtool": 6, "pkg": 6, "installed": 6, "your": 6, "debian": 6, "derivative": 6, "systems": 6, "you": 6, "do": 6, "sudo": 6, "apt": 6, "get": [6, 8], "install": 6, "build": 6, "essential": 6, "libuv1": 6, "dev": 6, "Then": 6, "run": 6, "autoreconf": 6, "configure": 6, "create": 6, "main": 6, "simple": 6, "test": 6, "program": 6, "runs": 6, "incrementing": 6, "counter": 6, "h": 6, "uv": 6, "static": 6, "12345": 6, "127": 6, "8080": 6, "dir": 6, "tmp": 6, "uv_loop_s": 6, "uv_raft_s": 6, "uv_timer_s": 6, "timer": 6, "uint64_t": 6, "command": [6, 7], "void": [6, 7], "timercb": 6, "uv_timer_t": 6, "buf": [6, 7], "uv_now": 6, "len": [6, 7], "sizeof": 6, "base": [6, 7], "uv_raft_submit": 6, "raft_command": [6, 7], "commitcb": 6, "uv_buf_s": 6, "printf": 6, "u": 6, "mkdir": 6, "0755": 6, "raft_configuration_init": 6, "raft_configuration_add": 6, "raft_voter": 6, "uv_loop_init": 6, "uv_raft_init": 6, "uv_timer_init": 6, "uv_raft_bootstrap": 6, "uv_raft_start": 6, "null": 6, "uv_timer_start": 6, "1000": 6, "uv_run": 6, "uv_run_default": 6, "compile": 6, "cc": 6, "lraft": 6, "luv": 6, "utilities": 7, "hold": 7, "value": 7, "64": 7, "bit": [7, 8], "long": 7, "expressed": 7, "milliseconds": 7, "epoch": 7, "buffer": 7, "pointer": 7, "raft_entry_type": 7, "application": [7, 8], "fsm": 7, "raft_barrier": 7, "wait": 7, "previous": 7, "commands": 7, "raft_change": 7, "change": [7, 8], "created": 7, "barrier": 7, "points": 7, "handle": 8, "user": 8, "call": 8, "persist": 8, "e": 8, "g": 8, "etc": 8, "manages": 8, "indicate": 8, "particular": 8, "action": 8, "define": 8, "raft_update_current_term": 8, "raft_update_voted_for": 8, "raft_update_entries": 8, "2": 8, "raft_update_snapshot": 8, "raft_update_state": 8, "5": 8, "raft_update_commit_index": 8, "6": 8, "raft_update_timeout": 8, "7": 8, "flag": 8, "changed": 8, "durably": 8, "done": 8, "processing": 8, "until": 8, "use": 8, "field": 8, "raft_update_snaposhot": 8, "chunk": 8, "obtained": 8}, "objects": {"": [[8, 0, 1, "c.RAFT_UPDATE_COMMIT_INDEX", "RAFT_UPDATE_COMMIT_INDEX"], [8, 0, 1, "c.RAFT_UPDATE_CURRENT_TERM", "RAFT_UPDATE_CURRENT_TERM"], [8, 0, 1, "c.RAFT_UPDATE_ENTRIES", "RAFT_UPDATE_ENTRIES"], [8, 0, 1, "c.RAFT_UPDATE_MESSAGES", "RAFT_UPDATE_MESSAGES"], [8, 0, 1, "c.RAFT_UPDATE_SNAPOSHOT", "RAFT_UPDATE_SNAPOSHOT"], [8, 0, 1, "c.RAFT_UPDATE_STATE", "RAFT_UPDATE_STATE"], [8, 0, 1, "c.RAFT_UPDATE_TIMEOUT", "RAFT_UPDATE_TIMEOUT"], [8, 0, 1, "c.RAFT_UPDATE_VOTED_FOR", "RAFT_UPDATE_VOTED_FOR"], [0, 1, 1, "c.raft", "raft"], [5, 1, 1, "c.raft_append_entries", "raft_append_entries"], [5, 1, 1, "c.raft_append_entries_result", "raft_append_entries_result"], [7, 1, 1, "c.raft_buffer", "raft_buffer"], [0, 3, 1, "c.raft_close", "raft_close"], [0, 3, 1, "c.raft_commit_index", "raft_commit_index"], [0, 3, 1, "c.raft_current_term", "raft_current_term"], [7, 1, 1, "c.raft_entry", "raft_entry"], [7, 5, 1, "c.raft_entry_type", "raft_entry_type"], [3, 1, 1, "c.raft_event", "raft_event"], [3, 5, 1, "c.raft_event_type", "raft_event_type"], [7, 6, 1, "c.raft_id", "raft_id"], [7, 6, 1, "c.raft_index", "raft_index"], [0, 3, 1, "c.raft_init", "raft_init"], [5, 1, 1, "c.raft_install_snapshot", "raft_install_snapshot"], [5, 1, 1, "c.raft_message", "raft_message"], [5, 5, 1, "c.raft_message_type", "raft_message_type"], [5, 1, 1, "c.raft_request_vote", "raft_request_vote"], [5, 1, 1, "c.raft_request_vote_result", "raft_request_vote_result"], [0, 5, 1, "c.raft_state", "raft_state"], [0, 3, 1, "c.raft_state", "raft_state"], [0, 3, 1, "c.raft_step", "raft_step"], [7, 6, 1, "c.raft_term", "raft_term"], [7, 6, 1, "c.raft_time", "raft_time"], [0, 3, 1, "c.raft_timeout", "raft_timeout"], [5, 1, 1, "c.raft_timeout_now", "raft_timeout_now"], [8, 1, 1, "c.raft_update", "raft_update"], [0, 3, 1, "c.raft_voted_for", "raft_voted_for"]], "raft": [[0, 2, 1, "c.raft.id", "id"]], "raft_close": [[0, 4, 1, "c.raft_close", "r"]], "raft_commit_index": [[0, 4, 1, "c.raft_commit_index", "r"]], "raft_current_term": [[0, 4, 1, "c.raft_current_term", "r"]], "raft_event": [[3, 2, 1, "c.raft_event.capacity", "capacity"], [3, 2, 1, "c.raft_event.catch_up", "catch_up"], [3, 2, 1, "c.raft_event.configuration", "configuration"], [3, 2, 1, "c.raft_event.persisted_entries", "persisted_entries"], [3, 2, 1, "c.raft_event.persisted_snapshot", "persisted_snapshot"], [3, 2, 1, "c.raft_event.receive", "receive"], [3, 2, 1, "c.raft_event.snapshot", "snapshot"], [3, 2, 1, "c.raft_event.start", "start"], [3, 2, 1, "c.raft_event.submit", "submit"], [3, 2, 1, "c.raft_event.time", "time"], [3, 2, 1, "c.raft_event.transfer", "transfer"], [3, 2, 1, "c.raft_event.type", "type"]], "raft_init": [[0, 4, 1, "c.raft_init", "address"], [0, 4, 1, "c.raft_init", "id"], [0, 4, 1, "c.raft_init", "r"]], "raft_state": [[0, 4, 1, "c.raft_state", "r"]], "raft_step": [[0, 4, 1, "c.raft_step", "event"], [0, 4, 1, "c.raft_step", "r"], [0, 4, 1, "c.raft_step", "update"]], "raft_timeout": [[0, 4, 1, "c.raft_timeout", "r"]], "raft_update": [[8, 2, 1, "c.raft_update.entries", "entries"], [8, 2, 1, "c.raft_update.flags", "flags"], [8, 2, 1, "c.raft_update.messages", "messages"], [8, 2, 1, "c.raft_update.snapshot", "snapshot"]], "raft_voted_for": [[0, 4, 1, "c.raft_voted_for", "r"]]}, "objtypes": {"0": "c:macro", "1": "c:struct", "2": "c:member", "3": "c:function", "4": "c:functionParam", "5": "c:enum", "6": "c:type"}, "objnames": {"0": ["c", "macro", "C macro"], "1": ["c", "struct", "C struct"], "2": ["c", "member", "C member"], "3": ["c", "function", "C function"], "4": ["c", "functionParam", "C function parameter"], "5": ["c", "enum", "C enum"], "6": ["c", "type", "C type"]}, "titleterms": {"raft": [0, 4], "algorithm": 0, "state": [0, 8], "data": [0, 3, 5, 7, 8], "types": [0, 3, 5, 7, 8], "public": [0, 8], "members": [0, 8], "api": [0, 1], "core": 1, "disk": 2, "format": 2, "raft_event": 3, "external": 3, "events": 3, "common": 3, "fields": 3, "start": [3, 6], "receive": 3, "persisted": 3, "entries": [3, 8], "snapshot": [3, 8], "configuration": 3, "taken": 3, "submit": 3, "catch": 3, "up": 3, "server": 3, "transfer": 3, "leadership": 3, "c": 4, "design": 4, "features": 4, "source": 4, "licence": 4, "raft_message": 5, "rpc": 5, "messages": [5, 8], "requestvote": 5, "result": 5, "appendentries": 5, "installsnapshot": 5, "timeoutnow": 5, "quick": 6, "basic": 7, "raft_update": 8, "updates": 8, "current": 8, "term": 8, "voted": 8, "commit": 8, "index": 8, "timeout": 8}, "envversion": {"sphinx.domains.c": 3, "sphinx.domains.changeset": 1, "sphinx.domains.citation": 1, "sphinx.domains.cpp": 9, "sphinx.domains.index": 1, "sphinx.domains.javascript": 3, "sphinx.domains.math": 2, "sphinx.domains.python": 4, "sphinx.domains.rst": 2, "sphinx.domains.std": 2, "sphinx": 60}, "alltitles": {"raft \u2014 Algorithm state": [[0, "raft-algorithm-state"]], "Data types": [[0, "data-types"], [3, "data-types"], [5, "data-types"], [7, "data-types"], [8, "data-types"]], "Public members": [[0, "public-members"], [8, "public-members"]], "API": [[0, "api"]], "Core API": [[1, "core-api"]], "Disk format": [[2, "disk-format"]], "raft_event \u2014 External events": [[3, "raft-event-external-events"]], "Common fields": [[3, "common-fields"]], "Start": [[3, "start"]], "Receive": [[3, "receive"]], "Persisted entries": [[3, "persisted-entries"]], "Persisted snapshot": [[3, "persisted-snapshot"]], "Configuration": [[3, "configuration"]], "Snapshot taken": [[3, "snapshot-taken"]], "Submit": [[3, "submit"]], "Catch-up server": [[3, "catch-up-server"]], "Transfer leadership": [[3, "transfer-leadership"]], "C-Raft": [[4, "c-raft"]], "Design": [[4, "design"]], "Features": [[4, "features"]], "Source": [[4, "source"]], "Licence": [[4, "licence"]], "raft_message \u2014 RPC messages": [[5, "raft-message-rpc-messages"]], "RequestVote": [[5, "requestvote"]], "RequestVote result": [[5, "requestvote-result"]], "AppendEntries": [[5, "appendentries"]], "AppendEntries result": [[5, "appendentries-result"]], "InstallSnapshot": [[5, "installsnapshot"]], "TimeoutNow": [[5, "timeoutnow"]], "Quick start": [[6, "quick-start"]], "Basic types": [[7, "basic-types"]], "raft_update \u2014 State updates": [[8, "raft-update-state-updates"]], "Current Term": [[8, "current-term"]], "Voted for": [[8, "voted-for"]], "Entries": [[8, "entries"]], "Snapshot": [[8, "snapshot"]], "Messages": [[8, "messages"]], "State": [[8, "state"]], "Commit index": [[8, "commit-index"]], "Timeout": [[8, "timeout"]]}, "indexentries": {"raft (c struct)": [[0, "c.raft"]], "raft.id (c member)": [[0, "c.raft.id"]], "raft_close (c function)": [[0, "c.raft_close"]], "raft_commit_index (c function)": [[0, "c.raft_commit_index"]], "raft_current_term (c function)": [[0, "c.raft_current_term"]], "raft_init (c function)": [[0, "c.raft_init"]], "raft_state (c enum)": [[0, "c.raft_state"]], "raft_state (c function)": [[0, "c.raft_state"]], "raft_step (c function)": [[0, "c.raft_step"]], "raft_timeout (c function)": [[0, "c.raft_timeout"]], "raft_voted_for (c function)": [[0, "c.raft_voted_for"]], "raft_event (c struct)": [[3, "c.raft_event"]], "raft_event.capacity (c member)": [[3, "c.raft_event.capacity"]], "raft_event.catch_up (c member)": [[3, "c.raft_event.catch_up"]], "raft_event.configuration (c member)": [[3, "c.raft_event.configuration"]], "raft_event.persisted_entries (c member)": [[3, "c.raft_event.persisted_entries"]], "raft_event.persisted_snapshot (c member)": [[3, "c.raft_event.persisted_snapshot"]], "raft_event.receive (c member)": [[3, "c.raft_event.receive"]], "raft_event.snapshot (c member)": [[3, "c.raft_event.snapshot"]], "raft_event.start (c member)": [[3, "c.raft_event.start"]], "raft_event.submit (c member)": [[3, "c.raft_event.submit"]], "raft_event.time (c member)": [[3, "c.raft_event.time"]], "raft_event.transfer (c member)": [[3, "c.raft_event.transfer"]], "raft_event.type (c member)": [[3, "c.raft_event.type"]], "raft_event_type (c enum)": [[3, "c.raft_event_type"]], "raft_append_entries (c struct)": [[5, "c.raft_append_entries"]], "raft_append_entries_result (c struct)": [[5, "c.raft_append_entries_result"]], "raft_install_snapshot (c struct)": [[5, "c.raft_install_snapshot"]], "raft_message (c struct)": [[5, "c.raft_message"]], "raft_message_type (c enum)": [[5, "c.raft_message_type"]], "raft_request_vote (c struct)": [[5, "c.raft_request_vote"]], "raft_request_vote_result (c struct)": [[5, "c.raft_request_vote_result"]], "raft_timeout_now (c struct)": [[5, "c.raft_timeout_now"]], "raft_buffer (c struct)": [[7, "c.raft_buffer"]], "raft_entry (c struct)": [[7, "c.raft_entry"]], "raft_entry_type (c enum)": [[7, "c.raft_entry_type"]], "raft_id (c type)": [[7, "c.raft_id"]], "raft_index (c type)": [[7, "c.raft_index"]], "raft_term (c type)": [[7, "c.raft_term"]], "raft_time (c type)": [[7, "c.raft_time"]], "raft_update_commit_index (c macro)": [[8, "c.RAFT_UPDATE_COMMIT_INDEX"]], "raft_update_current_term (c macro)": [[8, "c.RAFT_UPDATE_CURRENT_TERM"]], "raft_update_entries (c macro)": [[8, "c.RAFT_UPDATE_ENTRIES"]], "raft_update_messages (c macro)": [[8, "c.RAFT_UPDATE_MESSAGES"]], "raft_update_snaposhot (c macro)": [[8, "c.RAFT_UPDATE_SNAPOSHOT"]], "raft_update_state (c macro)": [[8, "c.RAFT_UPDATE_STATE"]], "raft_update_timeout (c macro)": [[8, "c.RAFT_UPDATE_TIMEOUT"]], "raft_update_voted_for (c macro)": [[8, "c.RAFT_UPDATE_VOTED_FOR"]], "raft_update (c struct)": [[8, "c.raft_update"]], "raft_update.entries (c member)": [[8, "c.raft_update.entries"]], "raft_update.flags (c member)": [[8, "c.raft_update.flags"]], "raft_update.messages (c member)": [[8, "c.raft_update.messages"]], "raft_update.snapshot (c member)": [[8, "c.raft_update.snapshot"]]}})